Codeforces Round #345 (Div. 2)【A.模拟,B,暴力,C,STL,容斥原理】

时间:2022-05-07
本文章向大家介绍Codeforces Round #345 (Div. 2)【A.模拟,B,暴力,C,STL,容斥原理】,主要内容包括A. Joysticks、B. Beautiful Paintings、C. Watchmen、基本概念、基础应用、原理机制和需要注意的事项等,并结合实例形式分析了其使用技巧,希望通过本文能帮助到大家理解应用这部分内容。

A. Joysticks

time limit per test:1 second

memory limit per test:256 megabytes

input:standard input

output:standard output

Friends are going to play console. They have two joysticks and only one charger for them. Initially first joystick is charged at a1 percent and second one is charged at a2 percent. You can connect charger to a joystick only at the beginning of each minute. In one minute joystick either discharges by 2 percent (if not connected to a charger) or charges by 1 percent (if connected to a charger).

Game continues while both joysticks have a positive charge. Hence, if at the beginning of minute some joystick is charged by 1 percent, it has to be connected to a charger, otherwise the game stops. If some joystick completely discharges (its charge turns to 0), the game also stops.

Determine the maximum number of minutes that game can last. It is prohibited to pause the game, i. e. at each moment both joysticks should be enabled. It is allowed for joystick to be charged by more than 100 percent.

Input

The first line of the input contains two positive integers a1 and a2 (1 ≤ a1, a2 ≤ 100), the initial charge level of first and second joystick respectively.

Output

Output the only integer, the maximum number of minutes that the game can last. Game continues until some joystick is discharged.

Examples

Input

3 5

Output

6

Input

4 4

Output

5

Note

In the first sample game lasts for 6 minute by using the following algorithm:

  • at the beginning of the first minute connect first joystick to the charger, by the end of this minute first joystick is at 4%, second is at 3%;
  • continue the game without changing charger, by the end of the second minute the first joystick is at 5%, second is at 1%;
  • at the beginning of the third minute connect second joystick to the charger, after this minute the first joystick is at 3%, the second one is at 2%;
  • continue the game without changing charger, by the end of the fourth minute first joystick is at 1%, second one is at 3%;
  • at the beginning of the fifth minute connect first joystick to the charger, after this minute the first joystick is at 2%, the second one is at 1%;
  • at the beginning of the sixth minute connect second joystick to the charger, after this minute the first joystick is at 0%, the second one is at 2%.

After that the first joystick is completely discharged and the game is stopped.

题目链接:http://codeforces.com/contest/651/problem/A

题意:现有两部手机,可是只有一根充电线。两个手机不可能同时充电。如果手机不充电的话,每分钟会降2%的点,如果充电的话可以每分钟可以涨1%的电。一旦其中有一部手机没电了就直接game over了。给出这两部手机的初始电量(初始电量不超过100,但你给他们充电的话电量可以超过100)。问两部手机最久能撑多久?

分析:直接模拟一下过程就好了,找出两部手机电量最小的不小于2即可!

下面给出AC代码:

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 int main()
 4 {
 5     int a1,a2;
 6     cin>>a1>>a2;
 7     int ans=0;
 8     while(1)
 9     {
10         if(a1<=a2)
11             swap(a1,a2);
12         if(a1<2)
13             break;
14         a1-=2;
15         a2+=1;
16         ans++;
17         if(a1<=0||a2<=0)
18             break;
19     }
20     cout<<ans<<endl;
21 }

B. Beautiful Paintings

time limit per test:1 second

memory limit per test:256 megabytes

input:standard input

output:standard output

There are n pictures delivered for the new exhibition. The i-th painting has beauty ai. We know that a visitor becomes happy every time he passes from a painting to a more beautiful one.

We are allowed to arranged pictures in any order. What is the maximum possible number of times the visitor may become happy while passing all pictures from first to last? In other words, we are allowed to rearrange elements of a in any order. What is the maximum possible number of indices i (1 ≤ i ≤ n - 1), such that ai + 1 > ai.

Input

The first line of the input contains integer n (1 ≤ n ≤ 1000) — the number of painting.

The second line contains the sequence a1, a2, ..., an (1 ≤ ai ≤ 1000), where ai means the beauty of the i-th painting.

Output

Print one integer — the maximum possible number of neighbouring pairs, such that ai + 1 > ai, after the optimal rearrangement.

Examples

Input

5
20 30 10 50 40

Output

4

Input

4
200 100 100 200

Output

2

Note

In the first sample, the optimal order is: 10, 20, 30, 40, 50.

In the second sample, the optimal order is: 100, 200, 100, 200.

题目链接:http://codeforces.com/contest/651/problem/B

题意:把a这个数组重新排列,使得序列中 满足条件ai+1>ai 的i尽可能的多,输出符合条件的i的数目。

分析:暴力可做,找出对应美丽值相同的最大个数t,n-t即为所求值!

下面给出AC代码:

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 int a[1010];
 4 int main()
 5 {
 6     int n,x;
 7     int ans=0,t=-1;
 8     cin>>n;
 9     for(int i=1;i<=n;i++)
10     {
11         cin>>x;
12         a[x]++;
13     }
14     for(int i=1;i<=1000;i++)
15         t=max(t,a[i]);
16     cout<<n-t<<endl;
17     return 0;
18 }

C. Watchmen

time limit per test:3 seconds

memory limit per test:256 megabytes

input:standard input

output:standard output

Watchmen are in a danger and Doctor Manhattan together with his friend Daniel Dreiberg should warn them as soon as possible. There are n watchmen on a plane, the i-th watchman is located at point (xi, yi).

They need to arrange a plan, but there are some difficulties on their way. As you know, Doctor Manhattan considers the distance between watchmen i and j to be |xi - xj| + |yi - yj|. Daniel, as an ordinary person, calculates the distance using the formula

.

The success of the operation relies on the number of pairs (i, j) (1 ≤ i < j ≤ n), such that the distance between watchman i and watchmen j calculated by Doctor Manhattan is equal to the distance between them calculated by Daniel. You were asked to compute the number of such pairs.

Input

The first line of the input contains the single integer n (1 ≤ n ≤ 200 000) — the number of watchmen.

Each of the following n lines contains two integers xi and yi (|xi|, |yi| ≤ 109).

Some positions may coincide.

Output

Print the number of pairs of watchmen such that the distance between them calculated by Doctor Manhattan is equal to the distance calculated by Daniel.

Examples

Input

3
1 1
7 5
1 5

Output

2

Input

6
0 0
0 1
0 2
-1 1
0 1
1 1

Output

11

Note

In the first sample, the distance between watchman 1 and watchman 2 is equal to |1 - 7| + |1 - 5| = 10 for Doctor Manhattan and

for Daniel. For pairs (1, 1), (1, 5) and (7, 5), (1, 5) Doctor Manhattan and Daniel will calculate the same distances.

题意:

钟表匠们的好基友马医生和蛋蛋现在要执行拯救表匠们的任务。在平面内一共有n个表匠,第i个表匠的位置为(xi, yi).

他们需要安排一个任务计划,但是确发现了一些问题很难解决。马医生从第i个表匠到第j个表匠所需要的时间为|xi - xj| + |yi - yj|。然而蛋蛋所需要的时间为

要想成功完成任务,必须保证两人从第i个表匠出发,同时到达第j个表匠。现在请你计算最多有多少组表匠的位置满足条件

分析:map去搞一搞就好了!

下面给出AC代码:【这个代码编译器运行不了,我也不知道为啥,队友写的,参考参考】

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 typedef long long ll;
 4 ll n,x,y,ans;
 5 map<ll,ll> a,b;
 6 map<pair<ll,ll>,ll> c;
 7 int main()
 8 {
 9     for(cin>>n;cin>>x>>y;)
10         ans+=(a[x]++)+(b[y]++)-(c[make_pair(x,y)]++);
11     cout<<ans<<endl;
12     return 0;
13 }

它解:容斥原理

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 struct Node
 4 {
 5     int a,b;
 6 }num[200100];
 7 bool cmp1(Node a,Node b)        //第一次排序
 8 {
 9     if(a.a==b.a)
10     {
11         return a.b<b.b;
12     }
13     return a.a<b.a;
14 }
15 bool cmp2(Node a,Node b)    //第二次排序
16 {
17     if(a.b==b.b)
18     {
19         return a.a<b.a;
20     }
21     return a.b<b.b;
22 }
23 int main()
24 {
25     int n;
26     while(~scanf("%d",&n))
27     {
28         for(int i=0;i<n;i++)
29         {
30             scanf("%d%d",&num[i].a,&num[i].b);
31         }
32         sort(num,num+n,cmp1);
33         __int64 temp=1;       //几个是相同的
34         __int64 tt=1;         //重复的个数
35         __int64 res=0;
36         for(int i=1;i<n;i++)
37         {
38             if(num[i].a==num[i-1].a)      //xi == xi-1
39             {
40                 temp++;
41                 if(num[i].b==num[i-1].b)
42                 {
43                     tt++;
44                 }
45                 else
46                 {
47                     res-=tt*(tt-1)/2;   //去重
48                     tt=1;
49                 }
50             }
51             else
52             {
53                 res+=temp*(temp-1)/2;       //排列组合,从temp个两两组合的个数
54                 res-=tt*(tt-1)/2;
55                 tt=1;
56                 temp=1;
57             }
58         }
59         if(tt!=1)       //判断结尾是不是有些没有去重
60         {
61             res-=tt*(tt-1)/2;
62         }
63         tt=1;
64         if(temp!=1)        //判断结尾有些是不是没有计算
65         {
66             res+=temp*(temp-1)/2;
67         }
68         temp=1;
69         sort(num,num+n,cmp2);       //第二次排序
70         for(int i=1;i<n;i++)
71         {
72             if(num[i].b==num[i-1].b)
73             {
74                 temp++;
75             }
76             else
77             {
78                 res+=temp*(temp-1)/2;
79                 temp=1;
80             }
81         }
82         if(temp!=1)
83         {
84             res+=temp*(temp-1)/2;
85         }
86         printf("%I64dn",res);
87     }
88     return 0;
89 }